// TestIpxDlg.cpp : implementation file
//

#include "stdafx.h"
#include "TestIpx.h"
#include "TestIpxDlg.h"

#ifdef _DEBUG
#pragma comment(lib,"IPX.LIB") 
#else
#pragma comment(lib,"IPX.LIB") 
#endif

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

#pragma warning(disable : 4996)
/////////////////////////////////////////////////////////////////////////////
// CAboutDlg dialog used for App About

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// Dialog Data
	//{{AFX_DATA(CAboutDlg)
	enum { IDD = IDD_ABOUTBOX };
	//}}AFX_DATA

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CAboutDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	//{{AFX_MSG(CAboutDlg)
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
	//{{AFX_DATA_INIT(CAboutDlg)
	//}}AFX_DATA_INIT
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAboutDlg)
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
	//{{AFX_MSG_MAP(CAboutDlg)
		// No message handlers
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CTestIpxDlg dialog

CTestIpxDlg::CTestIpxDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CTestIpxDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CTestIpxDlg)
	m_Message = _T("First Ethernet Message");
	m_RxSocketString.Format("RX: 0x%04X",RX_SOCKET);
	m_TxSocketString.Format("TX: 0x%04X",TX_SOCKET);;
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CTestIpxDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CTestIpxDlg)
	DDX_Control(pDX, IDC_PUTPACKET, m_PutButton);
	DDX_Text(pDX, IDC_EDIT1, m_Message);
	DDX_Text(pDX, IDC_RX_SOCKET, m_RxSocketString);
	DDX_Text(pDX, IDC_TX_SOCKET, m_TxSocketString);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CTestIpxDlg, CDialog)
	//{{AFX_MSG_MAP(CTestIpxDlg)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_BN_CLICKED(IDC_INITIALIZE, OnInitialize)
	ON_BN_CLICKED(IDC_PUTPACKET, OnPutpacket)
	ON_MESSAGE(IPX_WM_RXBUFFER,OnRecv)
	ON_BN_CLICKED(IDC_DEINSTALL, OnDeinstall)
	ON_WM_CTLCOLOR()
	ON_WM_CAPTURECHANGED()
	ON_MESSAGE(WM_MYICONNOTIFY,OnIcon)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CTestIpxDlg message handlers


BOOL CTestIpxDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Add "About..." menu item to system menu.

	// IDM_ABOUTBOX must be in the system command range.
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != NULL)
	{
		CString strAboutMenu;
		strAboutMenu.LoadString(IDS_ABOUTBOX);
		if (!strAboutMenu.IsEmpty())
		{
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_SYSTRAY, "Systray");
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
		}
	}

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon
	
	// TODO: Add extra initialization here
//	m_InitBitmap.LoadBitmap(IDB_INIT_BUTTON);
//	m_InitButton.SetBitmap((HBITMAP)m_InitBitmap);
//	m_CloseBitmap.LoadBitmap(IDB_CLOSE_BUTTON);
//	m_CloseButton.SetBitmap((HBITMAP)m_CloseBitmap);
	m_PutBitmap.LoadBitmap(IDB_PUT_BUTTON);
	m_PutButton.SetBitmap((HBITMAP)m_PutBitmap);
	m_newDialogColor.CreateSolidBrush(RGB(0, 155, 0)); 
	m_newEditBkColor.CreateSolidBrush(RGB(0,0,0)); 
	OnInitialize();
	return TRUE;  // return TRUE  unless you set the focus to a control
}

void CTestIpxDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else if ((nID & 0xFFF0) == IDM_SYSTRAY)
	{
		Systray();
	}
	else
	{
		CDialog::OnSysCommand(nID, lParam);
	}
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CTestIpxDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
		CDC* dc;
        dc=GetDC();
    
		dc->SetTextColor(RGB(255, 0, 0));
        dc->SetBkColor(RGB(0, 0, 0));
	//	dc->TextOut(70,20,"dwg"); 


		CPen pen;
		CBrush brush;
		CBrush brush1;
		brush.CreateSolidBrush(RGB(255,0,0));
		brush1.CreateSolidBrush(RGB(0,255,0));
		pen.CreatePen(PS_SOLID,1,RGB(194,243,245));
		dc->SelectObject(&pen);
		dc->SelectObject(&brush);
	//	dc->MoveTo(5,5);
	//	dc->LineTo(5,30);
		int x=0,y=5;
		dc->Ellipse(x+10,y+10,x+25,y+25);
		x= 270; 
		dc->Ellipse(x+10,y+10,x+25,y+25);
		dc->SelectObject(&brush1);
		x= 20 ;
		dc->Ellipse(x+10,y+10,x+25,y+25);
		x= 250 ;
		dc->Ellipse(x+10,y+10,x+25,y+25);

		//dc->Ellipse(20,40,10,10);

	}
}

// The system calls this to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CTestIpxDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}
//
void CTestIpxDlg::OnInitialize() 
{
 	ERRCODE ec ;
 	CString f;
// Define the window  for receive message
	ipx.SetHWND ( this->m_hWnd);
// Assign Windows Message
	ipx.Set_WM_IPX_RXBUFFER(IPX_WM_RXBUFFER);
// Define the TXSocket
	ipx.SetTxSocket(TX_SOCKET);
// Define the RxSocket
	ipx.SetRxSocket(RX_SOCKET);
// Open TxSocket
 	ec = ipx.CreateTxSocket();
	if (ec)
	{
 		f.Format("TX OPEN ERROR, ec= %d",ec) ;
		MessageBox(f,"ERROR",MB_ICONSTOP);
	}
// Open RxSocket
	ec = ipx.CreateRxSocket();
	if(ec)
	{
 		f.Format("RX OPEN ERROR, ec= %d",ec) ;
		MessageBox(f,"ERROR",MB_ICONSTOP); 		
	}
}
//
void CTestIpxDlg::OnPutpacket() 
{
	ERRCODE ec ;
  	UBYTE Message[512];
	CString message;
	UpdateData(true);
//	MessageBox (m_Message);
// Clear all locations
 	memset(&Message[0],0x00,512);
// Fill buffer with data 
 	strcpy((char*)&Message[0],(LPCSTR)m_Message);
// Define  the current dest network
 	ipx.SetNetwork(m_NetworkOfComputer);
// Send Packet
 	ec = ipx.PutPacket(&Message[0],m_Message.GetLength());
	if(ec)
	{
 		message.Format("SEND PACKET ERROR, ec= %d",ec) ;
		MessageBox(message,"ERROR",MB_ICONSTOP); 		
	}
	else
	{
		MessageBox((char*)Message,"SUCCESS",MB_OK); 	
	}
}
//
LRESULT CTestIpxDlg::OnRecv(WPARAM wParam,LPARAM lParam)
{
// Prepare the input data 
	ipx.OnReceive(wParam,lParam);
	
	ERRCODE ec ;
	UBYTE RcvBuffer[512];
	CString f;
// Clear all locations
 	memset(&RcvBuffer[0],0x00,512);
// Get the length of IPX packet
	UINT numberBytes = ipx.BytesInReceiveBuffer();
// Get data buffer
	ec = ipx.GetPacket(RcvBuffer,numberBytes);

	f.Format("%s, numberBytes = %d, ec = %d",RcvBuffer,numberBytes,ec);
	MessageBox(f,"Receive");
	return 0;
}
//
void CTestIpxDlg::OnDeinstall() 
{
	ipx.Deinstall();	
}
//
#if _MSC_VER == 1200
	void CTestIpxDlg::OnIcon(WPARAM wp, LPARAM lp)
#else
	LRESULT CTestIpxDlg::OnIcon(WPARAM wp, LPARAM lp)
#endif
{
	if (lp==515) 
	{
		ShowWindow(SW_RESTORE);
		DeleteSystray();
	}
#if _MSC_VER > 1200
	return 0;
#endif
}
//
HBRUSH CTestIpxDlg::OnCtlColor(CDC* pDC, CWnd* pWnd, UINT nCtlColor) 
{
    switch (nCtlColor) 
	{
	case	CTLCOLOR_EDIT:
	case	CTLCOLOR_STATIC:
		{
         //	AfxMessageBox("CtlColor");
			pDC->SetTextColor(RGB(100, 255, 0));
            pDC->SetBkColor(RGB(0, 0, 0));
            return (HBRUSH)m_newEditBkColor.GetSafeHandle();
		}
	default:	return m_newDialogColor;
	}
}
//
void CTestIpxDlg::OnCaptureChanged(CWnd *pWnd) 
{
	// TODO: Add your message handler code here
	
	CDialog::OnCaptureChanged(pWnd);
}
//
void CTestIpxDlg::Systray(void) 
{
	ShowWindow(SW_HIDE);
	NOTIFYICONDATA nf;
	nf.hWnd = m_hWnd;
	nf.uID = NULL;
	
	nf.uFlags = NIF_ICON | NIF_MESSAGE | NIF_TIP;
	nf.uCallbackMessage = WM_MYICONNOTIFY;
	strcpy(nf.szTip,"IPX Systray");

	HICON hIcon;
	hIcon=AfxGetApp()->LoadIcon(IDR_MAINFRAME);
	nf.hIcon = hIcon;
	Shell_NotifyIcon(NIM_ADD,&nf);
}
//
void CTestIpxDlg::OnCancel() 
{
	DeleteSystray();		
	OnDeinstall();
	CDialog::OnCancel();
}
//
void CTestIpxDlg::OnOK() 
{
	DeleteSystray();
	OnDeinstall();
	CDialog::OnOK();
}
//
void CTestIpxDlg::DeleteSystray()
{
	NOTIFYICONDATA nf;
	nf.hWnd = m_hWnd;
	nf.uID = NULL;
	nf.uFlags = NIF_ICON;
	nf.uCallbackMessage = NULL;
	nf.hIcon = NULL;
	Shell_NotifyIcon(NIM_DELETE,&nf);		
}
