/*

Ipx_defn.h - Ipx library function definitions

*/

#ifndef IDE_IPX_DEFN_H
#define IDE_IPX_DEFN_H

#define E_IPX(x)               1500+x

#define E_IPX_INIT_CREATE				E_IPX(1)
#define E_IPX_INIT_GETIPX				E_IPX(2)
#define E_IPX_INIT_SETIPX				E_IPX(3)
#define E_IPX_INIT_SETTIMEOUT			E_IPX(4)
#define E_IPX_WRITE_INIT				E_IPX(10)
#define E_IPX_WRITE_WRITE				E_IPX(11)
#define E_IPX_WRITE_TIMEOUT				E_IPX(12)
#define E_IPX_WRITE_ERROR				E_IPX(13)
#define E_IPX_WRITE_BADMSG				E_IPX(14)
#define E_IPX_PURGE_INIT				E_IPX(16)
#define E_IPX_PURGE						E_IPX(17)
#define E_IPX_READ_INIT					E_IPX(20)
#define E_IPX_READ_READ					E_IPX(21)
#define E_IPX_READ_TIMEOUT				E_IPX(22)
#define E_IPX_READ_ERROR				E_IPX(23)
#define E_IPX_READ_BADMSG				E_IPX(24)
#define E_IPX_READ_BADCRC1				E_IPX(25)
#define E_IPX_READ_BADCRC2				E_IPX(26)
#define E_IPX_RCV_TIMEOUT				E_IPX(30)
#define E_IPX_ESC_SETRTS				E_IPX(41)
#define E_IPX_ESC_CLRRTS				E_IPX(42)
#define E_IPX_ESC_SETDTR				E_IPX(43)
#define E_IPX_ESC_CLRDTR				E_IPX(44)
#define E_IPXUTIL_READ_FILE				E_IPX(51)
#define E_IPX_MODEM_STATUS				E_IPX(52)
#define E_IPX_CLEAR_IPX_ERROR			E_IPX(53)
#define E_IPX_STATE						E_IPX(54)
#define E_IPX_BUILD_DCB					E_IPX(55)
#define E_IPX_ALREADY_OPEN				E_IPX(56)
#define E_IPX_CREATE_READ_EVENT			E_IPX(57)
#define E_IPX_CREATE_WRITE_EVENT		E_IPX(58)
#define E_IPX_NO_INITIALIZATION			E_IPX(59)
#define E_IPX_INIT_PURGE				E_IPX(60)	
#define	E_IPX_INIT_SECOND_THREAD		E_IPX(61)
#define	E_IPX_RECEIVE_BUFFER_IS_EMPTY	E_IPX(62)
#define E_IPX_ERROR_STRING_PARITY		E_IPX(63)
#define	E_IPX_ERROR_STRING_STOP			E_IPX(64)
#define	E_IPX_ERROR_STRING_PORT			E_IPX(65)
#define	E_IPX_BUFFER_SIZE				E_IPX(66)
#define E_IPX_SMALL_BUFFER_SIZE			E_IPX(67)
#define E_IPX_NO_WINSOCKDLL				E_IPX(68)
#define	E_IPX_CREATE_TXSOCKET			E_IPX(69)
#define	E_IPX_CREATE_RXSOCKET			E_IPX(70)
#define	E_IPX_WM_MESSAGE				E_IPX(71)
#define E_IPX_INVALID_SOCKET			E_IPX(72)
#define	E_IPX_LINK_LOCAL_ADDRESS		E_IPX(73)
#define	E_IPX_ENABLE_BRODCAST			E_IPX(74)
#define	E_IPX_SEND_PACKET				E_IPX(75)
#define E_IPX_NO_DATA					E_IPX(76)


	
#endif // IDE_IPX_DEFN_H