// TestIpxDlg.h : header file
//

#if !defined(AFX_TESTIPXDLG_H__F0F88026_541D_11D5_9DD9_0000E8788EDB__INCLUDED_)
#define AFX_TESTIPXDLG_H__F0F88026_541D_11D5_9DD9_0000E8788EDB__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000
#include "ipx_helper.h"
#define WM_MYICONNOTIFY WM_USER+10

//
#define IDM_SYSTRAY		IDM_ABOUTBOX+0x50

#define REVERSE

#ifdef REVERSE
#define	TX_SOCKET	0x6201 
#define RX_SOCKET	0x6200
#else
#define	TX_SOCKET	0x6200 
#define RX_SOCKET	0x6201
#endif
/////////////////////////////////////////////////////////////////////////////
// CTestIpxDlg dialog

class CTestIpxDlg : public CDialog
{
// Construction
public:
	DWORD m_NetworkOfComputer;
	DWORD m_NetworkOfController;
	CTestIpxDlg(CWnd* pParent = NULL);	// standard constructor
#if _MSC_VER == 1200
	void OnIcon(WPARAM wp, LPARAM lp);
#else
	LRESULT OnIcon(WPARAM wp, LPARAM lp);
#endif
// Dialog Data
	//{{AFX_DATA(CTestIpxDlg)
	enum { IDD = IDD_TESTIPX_DIALOG };
	CButton	m_PutButton;
	CBitmap	m_PutBitmap;
	CString	m_Message;
	CString	m_RxSocketString;
	CString	m_TxSocketString;
	//}}AFX_DATA

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CTestIpxDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);	// DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	HICON m_hIcon;
	CIpx ipx;
	// Generated message map functions
	//{{AFX_MSG(CTestIpxDlg)
	virtual BOOL OnInitDialog();
	afx_msg void OnSysCommand(UINT nID, LPARAM lParam);
	afx_msg void OnPaint();
	afx_msg HCURSOR OnQueryDragIcon();
	afx_msg void OnInitialize();
	afx_msg void OnPutpacket();
	afx_msg LRESULT OnRecv(WPARAM wParam,LPARAM lParam);
	afx_msg void OnDeinstall();
	afx_msg HBRUSH OnCtlColor(CDC* pDC, CWnd* pWnd, UINT nCtlColor);
	afx_msg void OnCaptureChanged(CWnd *pWnd);
	afx_msg void OnCancelMode();
	virtual void OnCancel();
	virtual void OnOK();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
private:
	void DeleteSystray();
	void Systray(void);
	CBrush m_newDialogColor;
	CToolBar     m_newToolBar; 
	CBrush m_newEditBkColor;
};

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_TESTIPXDLG_H__F0F88026_541D_11D5_9DD9_0000E8788EDB__INCLUDED_)
